#!perl/nsPerl5.005_03/bin/nsperl
# The above points to a local copy of nsperl. This should be changed if
# use another perl or perl location
#
#
# This Search Engine is not a product of Rational Software and therefore 
# any difficulties resulting from the use of this Search Engine are not 
# covered by any support agreement held between the user and Rational 
# Software. This Search Engine was created by students at the University 
# of Technology  Sydney, Australia (www.uts.edu.au).
#
# DISCLAIMER
#
# THE MATERIAL AND/OR SOFTWARE IS PROVIDED AS IS.  RATIONAL AND ITS THIRD
# PARTY LICENSORS DISCLAIM ALL WARRANTIES EXPRESS OR IMPLIED INCLUDING, 
# WITHOUT LIMITATION, THE WARRANTY OF MERCHANTABILITY, NON-INFRINGEMENT, 
# TITLE OR FITNESS FOR A PARTICULAR PURPOSE OR ARISING OUT OF THE COURSE OF 
# DEALING, USAGE OR TRADE PRACTICE, CONTENT OF THE MATERIAL OR SOFTWARE.  
# RATIONAL MAKES NO WARRANTIES OR REPRESENTATIONS REGARDING THE ACCURACY OR 
# COMPLETENESS OF THE MATERIAL AND/OR SOFTWARE PROVIDED OR THAT IT WILL MEET 
# LICENSEES REQUIREMENTS OR THAT THE MATERIAL AND/OR SOFTWARE WILL BE ERROR 
# FREE.  IN NO EVENT SHALL RATIONAL OR ITS LICENSORS BE LIABLE TO LICENSEE OR 
# A THIRD PARTY FOR ANY INDIRECT, DIRECT, NEGLIGENCE, SPECIAL, OR CONSEQUENTIAL 
# DAMAGES INCLUDING LOST PROFITS, LOST DATA AND THE LIKE ARISING OUT OF OR IN 
# CONNECTION WITH THIS RECEIPT OF MATERIAL AND/OR SOFTWARE EVEN IF RATIONAL HAS 
# BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. 

#change this to absolute path of location of master indexes:
$basedir = "/usr2/rational/releases/apex.3.2.0b/doc/html/multi/master_index/";

$filename = $basedir."master_index_";
@letters =('A'..'X','Z');

unlink("index.dat");

foreach $letter (@letters)
{
	extract($filename.$letter.".html");
}

sub extract
{
print "processing ".$_[0]."\n";


open (INDEX, $_[0]) || die "not found";

$html_text = "";

while (<INDEX>) {
	$html_text .= $_;

}


$p = new HTML::SimpleParse( $html_text );

@list = ();
@chunk = ();
@refname= ();

foreach $node ($p->tree){
	push(@list, $node->{content});
}

open (OUT1, ">>index.dat");

$pop_me = 0;
$count = 0;
$ok_to_parse = 0;
$consecutive_keywords = 0;
$subkey_present = 0;
$grab_leading_keyword = 1;
$leading_keyword = "";

while ($count < @list) 
{
	if ($list[$count] eq 'DT' || $list[$count] eq 'dt' )
	{

		# pop_me is 0 when the DT's are being read, there may be multiple of these.
		# This way we can build up a list of keywords without needing a corresponding anchor.
		# However, when an anchor is parsed, pop_me is set to 1.
		# This way, when another DT comes along, we know we are moving into a new set of 
		# dt - anchor pairs, so write to file what we have, and start the process again.
		if($pop_me == 1)
		{
			dump_contents();
		}
          
		if ($list[$count+1] eq 'bold' || $list[$count+1] eq 'BOLD')
		{
			$count++;
	
			# OK to parse is set to 1 when the first DT is read. 
			# This way, we can ensure we don't pick up any href's at the start of the
			# html file that has nothing to do with the index itself
			$ok_to_parse = 1;
			$grab_leading_keyword = 1;
		}

		if ((!$list[$count+1] eq '') || (!$list[$count+1] eq '\t') || (!$list[$count+1] eq '\n'))
		{
			# This is a keyword, push it into our keyword array
			push (@chunk, $list[$count+1]);
			push (@refname, '');

			$consecutive_keywords++;

			if($grab_leading_keyword == 1)
			{
				$leading_keyword = $list[$count+1];
				$grab_leading_keyword = 0;
			}
		}

		if ($list[$count+1] eq "dl" || $list[$count+1] eq "DL")
		{
			# A sub-key, prepend next keyword with the leading keyword
			
			$subkey_present = 1;
		}                                     			

	}    
	elsif ($list[$count] eq "/dl" || $list[$count] eq "/DL")
	{
		# A good time to dump our collected text. Also, reset the leading keyword flag.
		dump_contents();
	}                                     			
	elsif ($list[$count] =~ /^[Aa]*/ && $ok_to_parse == 1)
	{
		#starts with A as in A HREF....

		%hash = $p->parse_args($list[$count]);

		if((!$hash{'href'} eq '') || (!$hash{'href'} eq '\t') || (!$hash{'href'} eq '\n'))
		{
			# If this a reference, push it into our reference array
			# Grab the anchor text name while we're there
			push(@chunk, $hash{'href'});
			push(@refname, $list[$count+1]);

			# We have read a reference in, so the next time we come across a DT
			# we know that we can write to file, and start again.
			$pop_me = 1;
		}
	}

	$count++;
}
}

sub dump_contents ()
{
	# This subroutine has a series of keywords (DT markers) and references
	# (Corresponding anchors). It will write them out together, along with a \n newline
	# character to seperate them from the next block of dt-anchor pairs.
	# This format should be easy to search on and extract.

	if($ok_to_parse == 1)
	{
		$part_of_index = 0;
		$ref_present = 0;

		while ($#chunk > -1)
		{	
			$chunk = shift(@chunk);
			$refname = shift(@refname);

			$chunk =~ s/\n//g;
	
			if (!($chunk =~ /\.\./)) 
			{
				# This is a keyword
				if($subkey_present == 1)
				{
					$leading_keyword =~ s/\bdl\b//;   #remove dl tag
					$chunk = "$leading_keyword;".$chunk;
					$subkey_present = 0;
				}

				$chunk =~ s/\bdl\b//;   #remove dl tag
				print OUT1 "$chunk ";	
				$part_of_index = 1;
			}
			else
			{
				if($part_of_index == 1)
				{
					# This is an anchor, format it appropriately.
					print OUT1 ":: <A HREF=\"../doc/html/multi/master_index/$chunk\">$refname</A> ";
					$ref_present = 1;
				}
			}
		}

		if($ref_present == 1)
		{
			print OUT1 "\n";
		}
	}
	else
	{
		# Just empty the array. If there is a perl command to do this quicker,
		# this loop should be replaced with that.
		foreach $chunk(@chunk)
		{
			$chunk = pop(@chunk);
			$refname = pop(@refname);
		}
	}
}


package HTML::SimpleParse;

#use strict;
#use vars qw($VERSION);

$VERSION = '0.08';
my $debug = 0;

sub new {
 my $pack = shift;
  
  my $self = bless {
		    'text' => shift(),
		    'tree' => [],
		   }, $pack;
  
  $self->parse if defined $self->{'text'};
  return $self;
}

sub text {
  my $self = shift;
  $self->{'text'} = shift if @_;
  return $self->{'text'};
}

sub tree { @{$_[0]->{'tree'}} }

sub parse {
  # Much of this is a dumbed-down version of HTML::Parser::parse.
  
  my $self = shift;
  my $text = \ $self->{'text'};
  my $tree = $self->{'tree'};
  
  # Parse html text in $$text.  The strategy is to remove complete
  # tokens from the beginning of $$text until we can't decide whether
  # it is a token or not, or the $$text is empty.
  
  @$tree = ();
  while (1) {
    my ($content, $type);
    
    # First we try to pull off any plain text (anything before a "<" char)
    if ($$text =~ /\G([^<]+)/gcs) {
      $content = $1; $type = 'text';
      
      # Then, SSI, comments, and markup declarations (usually <!DOCTYPE...>)
      # ssi:     <!--#stuff-->
      # comment: <!--stuff-->
      # markup:  <!stuff>
    } elsif ($$text =~ /\G<(!--(\#?).*?--)>/gcs) {
      $type = ($2 ? 'ssi' : 'comment');
      $content = $1;
      
    } elsif ($$text =~ /\G<(!.*?)>/gcs) {
      $type = 'markup';
      $content = $1;
      
      # Then, look for an end tag
    } elsif ($$text =~ m|\G<(/[a-zA-Z][a-zA-Z0-9\.\-]*\s*)>|gcs) {
      $content = $1; $type = 'endtag';
      
      # Then, finally we look for a start tag
      # We know the first char is <, make sure there's a >
    } elsif ($$text =~ /\G<(.*?)>/gcs) {
      $content = $1; $type = 'starttag';
      
    } else {
      # the string is exhausted, or there's no > in it.
      push @$tree, {
		    'content' => substr($$text, pos $$text),
		    'type'    => 'text',
		   } unless pos($$text) eq length($$text);
      last;
    }
    
    push @$tree, {
		  'content' => $content,
		  'type'    => $type,
		 };
  }
  
  $self;
}

sub parse_args {
  my $self = shift;  # Not needed here
  my @returns;
  
  # Make sure we start searching at the beginning of the string
  pos($_[0]) = 0;
  
  while (1) {
    next if $_[0] =~ m/\G\s+/gc;  # Get rid of leading whitespace
    
    if ( $_[0] =~ m/\G
	 (\S+?)\s*=\s*                            # the key
	 (?:
	  "([^\"\\]*  (?: \\.[^\"\\]* )* )"\s*    # quoted string, with possible whitespace inside,
	  |                                       #  or
	  ([^\s>]*)\s*                            # anything else, without whitespace or >
	 )/gcx ) {
      
      my ($key, $val) = ($1, $+);
      $val =~ s/\\(.)/$1/gs;
      push @returns, $key, $val;
      
    } elsif ( $_[0] =~ m/\G(\S+)\s*/gc ) {
      push @returns, $1, undef;
    } else {
      last;
    }
  }
  
  return @returns;
}


sub execute {
  my $self = shift;
  my $ref = shift;
  my $method = "output_$ref->{type}";
  warn "calling $self->$method(...)" if $debug;
  return $self->$method($ref->{content});
}

sub get_output {
  my $self = shift;
  my ($method, $out) = ('', '');
  foreach ($self->tree) {
    $out .= $self->execute($_);
  }
  return $out;
}


sub output {
  my $self = shift;
  my $method;
  foreach ($self->tree) {
    print $self->execute($_);
  }
}

sub output_text      {   $_[1]; }
sub output_comment   { "<$_[1]>"; }
sub output_endtag    { "<$_[1]>"; }
sub output_starttag  { "<$_[1]>"; }
sub output_markup    { "<$_[1]>"; }
sub output_ssi       { "<$_[1]>"; }
