#!perl/nsPerl5.005_03/bin/nsperl
# The above points to a local copy of nsperl. This should be changed if
# use another perl or perl location
#
#
# This Search Engine is not a product of Rational Software and therefore 
# any difficulties resulting from the use of this Search Engine are not 
# covered by any support agreement held between the user and Rational 
# Software. This Search Engine was created by students at the University 
# of Technology  Sydney, Australia (www.uts.edu.au).
#
# DISCLAIMER
#
# THE MATERIAL AND/OR SOFTWARE IS PROVIDED AS IS.  RATIONAL AND ITS THIRD
# PARTY LICENSORS DISCLAIM ALL WARRANTIES EXPRESS OR IMPLIED INCLUDING, 
# WITHOUT LIMITATION, THE WARRANTY OF MERCHANTABILITY, NON-INFRINGEMENT, 
# TITLE OR FITNESS FOR A PARTICULAR PURPOSE OR ARISING OUT OF THE COURSE OF 
# DEALING, USAGE OR TRADE PRACTICE, CONTENT OF THE MATERIAL OR SOFTWARE.  
# RATIONAL MAKES NO WARRANTIES OR REPRESENTATIONS REGARDING THE ACCURACY OR 
# COMPLETENESS OF THE MATERIAL AND/OR SOFTWARE PROVIDED OR THAT IT WILL MEET 
# LICENSEES REQUIREMENTS OR THAT THE MATERIAL AND/OR SOFTWARE WILL BE ERROR 
# FREE.  IN NO EVENT SHALL RATIONAL OR ITS LICENSORS BE LIABLE TO LICENSEE OR 
# A THIRD PARTY FOR ANY INDIRECT, DIRECT, NEGLIGENCE, SPECIAL, OR CONSEQUENTIAL 
# DAMAGES INCLUDING LOST PROFITS, LOST DATA AND THE LIKE ARISING OUT OF OR IN 
# CONNECTION WITH THIS RECEIPT OF MATERIAL AND/OR SOFTWARE EVEN IF RATIONAL HAS 
# BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.  

#
# User Defined Environment Variables					

# The absolute path for the search to start at
$basedir = '/usr2/rational/releases/apex.3.2.0b/doc/html/all';

# The url that the above refers to
$baseurl = 'http://localhost:8080/usr2/rational/releases/apex.3.2.0b/doc/html/all/';

# The list of files which the search will look for and in which directories (can have more than one)
@files = ('*/*.html');
#
# Directories in the @ignore array are directories the search script will skip.
#
@ignore = ('master_index');

$title = "Apex Documentation";
$title_url = 'http://localhost:8080/';
# $search_url = 'http://charlie.socs.uts.edu.au/~pmmcinto/html_search/search.html';
$search_url = 'http://usr2/rational/releases/apex.3.2.0b/doc/html/multi/reference/WELCOME_TO.html';



# $debug should be set to 1 if you are debugging the script to work.  And 0 if
# you are done debugging and ready to use the search script online.

$debug = 0;    # 1 = Yes | 0 = No
#
# set $disp_ignore, if you want the directories listed in @ignore displayed 
# on the final resultes page or 0 if you do not wish them displayed.
#
$disp_ignore = 0;    # 1 = Yes | 0 = No
#

# Parse Form Search Information
&parse_form;

# If debug is set to yes, display files only.
if ($debug eq "1") {
	&debug;
}
else {
	# Get Files To Search Through
	&get_files;
}

if ($debug eq "0") {
	# Search the files
	&search;
}

# Print Results of Search
&return_html;

sub parse_form {

   # Get the input
   read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});

   # Split the name-value pairs
   @pairs = split(/&/, $buffer);

   foreach $pair (@pairs) {
      ($name, $value) = split(/=/, $pair);

      $value =~ tr/+/ /;
      $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;

      $FORM{$name} = $value;
   }
}

sub get_files {
   chdir($basedir);
	$pwd=`pwd`;
	foreach $file (@files) {
		$ls = `ls $file`;
		@ls = split(/\s+/,$ls);
		foreach $temp_file (@ls) {
			foreach $ignore (@ignore) {
				if ($temp_file =~ $ignore) {
					push(@SKIP,$temp_file);
				}
				elsif (-d $file) {
					$filename = "$file$temp_file";
					if (-T $filename) {
						push(@FILES,$filename);
					}
				}
				elsif (-T $temp_file) {
					push(@FILES,$temp_file);
				}
			}
		}
	}
}


sub search {

   @terms = split(/\s+/, $FORM{'terms'});
   foreach $i (@terms) {
	$terms[$i]=quotemeta($terms[$i]);
	}

   foreach $FILE (@FILES) {

      open(FILE,"$FILE");
      @LINES = <FILE>;
      close(FILE);

      $string = join(' ',@LINES);
      $string =~ s/\n//g;
      if ($FORM{'boolean'} eq 'AND') {
         foreach $term (@terms) {
            if ($FORM{'case'} eq 'Insensitive') {
               if (!($string =~ /$term/i)) {
                  $include{$FILE} = 'no';
				last;
               }
               else {
                  $include{$FILE} = 'yes';
		  $context{$FILE} = getcontext($`, $&, $', 200);
               }
            }
            elsif ($FORM{'case'} eq 'Sensitive') {
               if (!($string =~ /$term/)) {
                  $include{$FILE} = 'no';
                  last;
               }
               else {
                  $include{$FILE} = 'yes';
		  $context{$FILE} = getcontext($`, $&, $',200);
               }
            }
         }
      }
      elsif ($FORM{'boolean'} eq 'OR') {
         foreach $term (@terms) {
            if ($FORM{'case'} eq 'Insensitive') {
               if ($string =~ /$term/i) {
                  $include{$FILE} = 'yes';
		  $context{$FILE} = getcontext($`, $&, $', 200);
                  last;
               }
               else {
                  $include{$FILE} = 'no';
               }
            }
            elsif ($FORM{'case'} eq 'Sensitive') {
               if ($string =~ /$term/) {
		  $include{$FILE} = 'yes';
		  $context{$FILE} = getcontext($`, $&, $', 200);
                  last;
               }
               else {
                  $include{$FILE} = 'no';
               }
            }
         }
      }
      if ($string =~ /<title>(.*)<\/title>/i) {
         $titles{$FILE} = "$1$FILE";
	 if (length($titles{$FILE}) > 100 )
	 { 
		$titles{$FILE} = "$pwd$FILE";
	 }

      }
      else {
         $titles{$FILE} = "$pwd$FILE";
      }
   }
}

sub getcontext {

	$frontpart = substr($_[0], length($_[0]) - $_[3]);

	$matchedpart = $_[1];

	$backpart =  substr($_[2], 0, $_[3]);

	if ($frontpart =~ /\</)
	{
		$pos1 = 0;
		$pos1 = length($`);
		$pos2 = 0;

		if ($frontpart =~ /\>/)
		{
			$pos2 = length($`);
		}		

		if ($pos1 > $pos2 || $pos1 == 0)	
		{
			$frontpart = substr($frontpart, $pos2 + 1);
		}
	}	

	$reverse = reverse($backpart);

	if ($reverse =~ /\</)
	{
		$pos1 = 0;
		$pos1 = length($`);
		$pos2 = 0;

		if ($reverse =~ /\>/)
		{
			$pos2 = length($`);
		}		

		if ($pos1 < $pos2 || $pos2 == 0)	
		{
			$backpart = substr($backpart, 0, length($backpart) - $pos1 - 1);
		}
	}	

	$ret = $frontpart.$matchedpart.$backpart;
	
	#remove tags

	$i=0;
	$len = length($ret);
	$sw = 0;
	$res = "";
	
	while($i < $len)
	{
		$c =  substr($ret, $i , 1 );
		
		if ($c eq "\<")
		{
			$sw += 1;

		}
		elsif ($c eq "\>")
		{
			$sw -= 1;

		}
		elsif ($sw == 0)
		{
			$res .= $c;
		}

		$i++;

	}	
	$res =~ s/(\S+)//;
	return $res;

}

sub return_html {
	$count=0;
	foreach $key (keys %include) {
		if ($include{$key} eq 'yes') {
			$count++;
		}
	}
	if ($count eq "0" && ($debug eq "0")) {
		&display_no_hits;
	}
	else {
	   print "Content-type: text/html\n\n";
	   print "<html>\n <head>\n  <title>Results of Search</title>\n </head>\n";
	   print "<body bgcolor=#FFFFFF text=#000000>\n <h4><font
color=\"#AD0045\"> <center>\n
<h1>Results of Search in $title</h1>\n </center>\n</h4></font>";
		print "<p><hr size=7 width=75%><p>\n";
		if ($debug eq "1") {
				print "DEBUG MODE ON! SEARCH IS DISABLED!<p>\n";
				if ($basedir =~http) {
				   print "Your \$basedir is incorrect, it needs to be a path not a URL!\n";
					exit;
				}
				chop($pwd);
				if ($pwd eq $basedir) {
					print "I was successfully able to change to the \$basedir: <b>$basedir</b><p>\n";
				}
				else {
					print "I tried changing to: <b>$basedir</b>, which is what you defined as your \$basedir.<br>";
					print "However, I was unable to change to that directory, (perhaps because your \$basedir is invalid),<br>instead I defaulted to <b>$pwd</b>.<br>";
				}
				if ($filedir eq "") {
					print "<p>There are either no files in this directory, or authorization (permissions) will not allow me to list those files here.<p>\n";
				}
				else {
					print "If the following files are not the files you are attempting to search, or there are no files listed, your \$basedir is set up incorrectly!<p>\n";
					print "<p><pre><b>$filedir</b></pre>\n";
				}
			}
			else {
			   print "<ul>\n";
				foreach $key (keys %include) {
					if ($include{$key} eq 'yes') {
						print "<li><a
href=\"$baseurl$key\">$FILE{$key}</a>\n";
	print "$titles{$key} <br>URL: <a
href=\"$baseurl$key\">$key</a>\n";
			print "<br>$context{$key}<p><br>";
					}
				}
			}   

			print "</ul>\n";
  		 print "<hr size=7 width=75%>\n";
			if ($debug eq "0") {
			   print "Search Information:<p>\n";
				print "<ul>\n";
				print "<li><b>Terms:</b> ";
				$i = 0;
				foreach $term (@terms) {
					print "$term";
			      $i++;
					if (!($i == @terms)) {
		   			 print ", ";
			      }
				}
			   print "\n";
			   print "<li><b>Boolean Used:</b> $FORM{'boolean'}</li>\n";
			   print "<li><b>Case</b> $FORM{'case'}</li>\n";
				print "<li><b>Total Hits Found:</b> $count</li>\n";
				if ($disp_ignore eq "1") {
					print "<li><b>Ignored The Following Directories:</b> ";
					$h = 0;
					foreach $ignore (@ignore) {
						print "$ignore";
						$h++;
						if (!($h == @ignore)) {
							print ", ";
						}
					}
				}
			   print "</ul><br><hr size=7 width=75%><P>\n";
			   #print "<ul>\n<li><a href=\"$search_url\">Back to Search Page</a></li>\n";
			   #print "<li><a href=\"$title_url\">$title</a></li>\n";
			   #print "</ul>\n";
			   #print "<hr size=7 width=75%>\n";
			}
			 print "</body>\n</html>\n";
		}
}

sub debug {
	chdir($basedir);
	$pwd=`pwd`;
	$filedir=`ls -l`;
}
		
sub display_no_hits {
   print "Content-type: text/html\n\n";
   print "<html>\n <head>\n  <title>No Hits</title>\n </head>\n";
	print "<body bgcolor=#FFFFFF text=#000000>\n<font
color=\"#AD0045\"> 
<center>\n <h1>Sorry - Your Search Yielded No Results</h1>\n
</center>\n</font>";
#   print "<ul>\n<li><a href=\"$search_url\">Back to Search Page</a>\n";
#   print "<li><a href=\"$title_url\">$title</a>\n";
#   print "</ul>\n";
#   print "<hr size=7 width=75%>\n";
	print "</body>\n</html>\n";
	exit;
}
